close all
I = rgb2gray(imread('4.jpg'));%prevod na sedotonovy obraz
BW = edge(I);%nalezeni hran v obraze
imshow(I)
figure, imshow(BW)
theta = 0:179;%uhly pro ktere budeme pocitat projekci
[R,xp] = radon(BW,theta);%vypocet projekci
figure, imagesc(theta, xp, R); colormap(hot);
xlabel('\theta (degrees)'); ylabel('X\prime');
title('R_{\theta} (X\prime)');
colorbar
figure
imshow(R>90)
figure
i = find(R>90);%nalezeni indexu prvku vetsich nez 90
%Sort the output and pick the top lines
[foo,ind] = sort(-R(i));%serazeni indexu podle velikosti cisel na ktere ukazuji
k = i(ind(1:50));%vyber 50 bodu
[y,x] = ind2sub(size(R),k); %konvertuje indexy na souradnice
%vykresleni primek
imagesc(theta,xp,R), colorbar;
xlabel ('theta (deg)'), ylabel ('rho (pixels from center)')
%numplot([theta(x) xp(y)']), title('location of peaks');  
%Find the theta and rho values for the peak coordinates.  Note that matlab's radon function uses an upside-down convention for specifying the rotation (theta).  Therefore, I just negate the theta value to compensate.
t = (-theta(x)*pi/180)';
r = xp(y);  
%The lines parameters are computed as follows.  The line parameters have the coefficents of the equation Ax + By + C = 0, and are invarient to scale.  However this particular scaling will produce the distance of a point to the line with the dot product: [A; B; C]' * [x; y; 1].
lines = [cos(t) sin(t) -r];  
%Transform the line from the center of the image to the upper left.  (The minus ones are for matlabs 1 based coordinates.)
cx = size(I,2)/2-1;
cy = size(I,1)/2-1;
lines(:,3) = lines(:,3) - lines(:,1)*cx - lines(:,2)*cy;  
%Here are the top lines drawn on the gradient image
imshow(BW); title('Gradient image with lines');
draw_lines(lines);  

        

